with Reps, Messages, Balls, MiniFuns, RGParam, RG;
use Reps, Messages, Balls, MiniFuns, RGParam;

pragma Elaborate_All (Balls);

procedure CheckDM is  --- check contraction

  type Scalar is new Ball;

  PDeg:     constant Natural := 30; --- degree of polyomial approximations
  SVDim:    constant Natural := 30; --- matrix dimension

  package VRG is new RG (PDeg => PDeg, SVDim => SVDim, Scalar => Scalar);
  use VRG, VRG.RG_Funs, VRG.RG_Taylors, VRG.RGV, VRG.RGV.ScalVecs;

  A_G:  constant Args      := (T0,S0,B0,Rep(0));  --- defines variables U,V

  K: Scalar;
  A: SMat;
  B: RGData;

begin

  Verbosity := 0;  --- increase for more info

  --- read RG data and matrix M
  Read("rg.data",B);
  Read("matrix30.data",A);
  Normalize(A_G,A);

  --- estimate derivative DM of M
  K := DContractNorm(B,A);
  Show("||DM(ball)||  ",Sup(K));
  Check(Sup(K)<KMax);

  --- B.G contains fixed point of N
  BasicData(B.G);

  Show("CheckDM: Done.");

end CheckDM;
