with Reps, Messages, Balls, MiniFuns, RGParam, RG;
use Reps, Messages, Balls, MiniFuns, RGParam;

pragma Elaborate_All (Balls);

procedure CheckMaps is  --- check domains and ranges of maps

  type Scalar is new Ball;

  PDeg:     constant Natural := 30; --- degree of polyomial approximations
  SVDim:    constant Natural := 30; --- matrix dimension

  package VRG is new RG (PDeg => PDeg, SVDim => SVDim, Scalar => Scalar);
  use VRG, VRG.RG_Funs, VRG.RG_Taylors, VRG.RGV, VRG.RGV.ScalVecs;

  Rec:  constant Rectangle := (X0,X1,Z0,Z1);

  B: RGData;
  M: MapData;

begin

  Verbosity := 0;  --- increase for more info

  --- read and prepare data
  Read("rg.data",B);
  MakeMapData(B,Rec,M);

  --- verify that we have a commuting pair
  Show("Checking that J is the identity");
  CheckJ(M);

 --- check map domains and twist condition
  CheckMaps(M);

  Show("CheckMaps: Done.");

end CheckMaps;
