with Taylors2.Num;

pragma Elaborate_All (Taylors2.Num);

generic

package Funs2.Num is -- purely numerical procedures

  pragma Elaborate_Body;

  function NumInv(F: Fun) return Fun;                                -- 1/F
  procedure NumInv(L: in out Flop);                                  -- inverse of L
  procedure NumCompZero(F,G: in Fun; R: in RadPair; V: in out Fun);  -- compute midpoint V
  procedure NumCompZeroD(F,G: in Fun; R: in RadPair; V: in out Fun); -- compute midpoint V
  procedure VApprox(D: in Domain; V: out Fun);                       -- read/save vapprox.data
  function GuessRho(F: Fun) return RadPair;                          -- guess radii, for experiments
  procedure RhoInfo(N: in String; F: in Fun; Rn: in RadPair);        -- compare/show radii

  package Taylors_Num is new Taylors.Num;
  use Taylors_Num;

  VHave: Boolean := False;
  VSave: Fun;

end Funs2.Num;
