with Ada.Text_IO;
use Ada.Text_IO;

package Reps.IO is

  pragma Elaborate_Body;

  package Rep_IO is new Ada.Text_IO.Float_IO(Rep);

  procedure Show0(N: in String);
  procedure Show1(N: in String; R: in Rep);
  procedure Show2(N: in String; R1,R2: in Rep);
  procedure Show3(N: in String; R1,R2,R3: in Rep; NewLine: in Boolean := True);
  procedure Get(F: in File_Type; R: out Rep; Decimal: in Boolean := True);
  procedure Get(F: in File_Type; R1,R2: out Rep; Decimal: in Boolean := True);
  procedure Get(F: in File_Type; R1,R2,R3: out Rep; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; R: in Rep; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; R1,R2: in Rep; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; R1,R2,R3: in Rep; Decimal: in Boolean := True);

  function Val(S: String) return Rep;        -- convert Hex String to Rep
  function HexStr(I: Integer) return String; -- convert Integer to Hex String
  function HexStr(R: Rep) return String;     -- convert Rep to Hex String

private

  HexDig: constant array(0 .. 15) of Character
          := ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

end Reps.IO;
