with Reps;
use Reps;

package RGParam is

  --- defines variables U,V for G
  T0:   constant Rep       := Rep(51)/Rep(128);   --- 0.39843750
  S0:   constant Rep       := Rep(307)/Rep(256);  --- 1.19921875
  B0:   constant Rep       := Rep(3);

  --- domain for G and contracted G
  R1:   constant Rep       := Rep(7)/Rep(4);      --- 1.75
  R2:   constant Rep       := Rep(3)/Rep(4);      --- 0.75
  R_G:  constant RadPair   := (R1,R2);            --- domain for G
  Fac:  constant Rep       := Rep(17)/Rep(16);    --- 1.0625
  Rt:   constant RadPair   := (Fac*R1,Fac*R2);    --- domain for contracted G

  --- desired bound on the contraction factor
  KMax: constant Rep       := Rep(35)/Rep(64);    --- 0.546875

  --- defines rectangle
  X0:   constant Rep       := Rep(-107)/Rep(256); -- -0.41796875
  X1:   constant Rep       := Rep(9)/Rep(8);      --- 1.125
  Z0:   constant Rep       := Rep(-6);
  Z1:   constant Rep       := Rep(251)/Rep(128);  --- 1.9609375

end RGParam;

