with Interfaces.C;
use Interfaces.C;

package Rounding is          -- uses libm and libc functions

  procedure Relax_Checks;    -- round to nearest, mask exceptions
  procedure Restore_Checks;  -- round up, unmask exceptions

private

  function FE_Test_Except(Exceptions: in Int) return Int;
  function FE_Clear_Except(Exceptions: in Int) return Int;
  function FE_Enable_Except(Exceptions: in Int) return Int;
  function FE_Disable_Except(Exceptions: in Int) return Int;
  function FE_Set_Round(Rounding_Mode: in Int) return Int;

--- these C functions need to exist in the C math library
  pragma Import(C,FE_Test_Except,"fetestexcept");
  pragma Import(C,FE_Clear_Except,"feclearexcept");
  pragma Import(C,FE_Enable_Except,"feenableexcept");
  pragma Import(C,FE_Disable_Except,"fedisableexcept");
  pragma Import(C,FE_Set_Round,"fesetround");

--- for x87 co-processor
--- on other systems, see fenv.h for correct values
  Excepts: constant Int := 16#01F#; --- underflow, overflow, divbyzero, denorm, invalid
  Nearest: constant Int := 16#000#; --- round to nearest
  Upwards: constant Int := 16#800#; --- round up

  I: Int;

end Rounding;
